#!/usr/bin/env python2
import os
import time
import json
import requests
import psutil

#setting
user = "park"
parkDir = "/dxpark/service/parkos"
rtspDir = "/dxpark/service/RTSPtoWebRTC"
frpDir = "/dxpark/service/frpc"

ntdDir = "/dxpark/service/easyntd"
nvrDir = "/dxpark/service/EasyNVR"
darwinDir = "/dxpark/service/EasyDarwin"

#host = "192.168.1.10"
host = "weixin.hjzhparking.com"

def sendHook(msg):
	try:
		macadd = os.popen("cat /sys/class/net/*/address").read().replace(":","").split("\n")[0]
		url = "http://"+host+"/dxparkapi/park/login/hook/shell"
		print(url)
		headers = {"content-type":"application/json","charset":"utf-8"}
		resp = requests.get(url, params={"mac":macadd,"msg":msg}, headers=headers)
		respData = json.dumps(resp.json(), False)
		print("hook resp:%s" % respData)
	except:
		print("hook {} error.", url)
def systemCheck():
	memory_info = psutil.virtual_memory()
	print("memory total:{}M,used:{}%".format(memory_info.total/1024/1024, memory_info.percent))
	disk_info = psutil.disk_usage("/")
	disk_total = disk_info.total/1024/1024
	disk_used = disk_info.used/1024/1024
	disk_free = (disk_total-disk_used)
	print("disk total:{}G,used:{}G,free:{}G".format(disk_total/1024, disk_used/1024,disk_free/1024))
	if memory_info.percent>95.0:
		sendHook("memory used upto %s" % memory_info.percent)
		print(os.popen("ps aux --sort=-%mem | head -n 11 | tail -n 10").read())
	if disk_free<1024.0:
		sendHook("disk used for free %sM" % disk_free)
		

# work log
print("begin timer service check by %s" % time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(time.time())))

#redis check
print("1>> begin check redis...")
redisid = os.popen("ps -ef | grep redis | grep -v check |  grep -v grep | awk 'NR==1{print $2}'").read()
if redisid=='':
    redisid=0
else:
    redisid=int(redisid)
print("redis workid is[%d]" % redisid)
if redisid > 10:
    print("redis is running...")
else:
    print("redis begin starting...")
    print(os.system("su - {} -c /usr/local/redis/src/redis-server  /usr/local/redis/redis.conf > /dev/null 2>&1 &".format(user)))
    sendHook("redis stoped to restart.")
print("1>> end check redis...")

#nginx service check
print("2>> begin check nginx...")
if os.path.exists("/usr/local/nginx/") and os.path.isdir("/usr/local/nginx/"):
	nginxid = os.popen("ps -ef | grep nginx | grep -v check |  grep -v grep | awk 'NR==1{print $2}'").read()
	if nginxid=='':
		nginxid=0
	else:
		nginxid=int(nginxid)
	print("nginx workid is[%d]" % nginxid)
	if nginxid > 10:
		print("nginx is running...")
	else:
		print("nginx begin starting...")
		print(os.system("su - {} -c /usr/local/nginx/sbin/nginx".format(user)))
		sendHook("nginx stoped to restart.")
else:
	print("nginx dir not exist")
print("2>> end check nginx...")

# frpc service check
print("3>> begin check frpc...")
frpid = os.popen("ps -ef | grep frpc | grep -v check |  grep -v grep | awk 'NR==1{print $2}'").read()
if frpid=='':
	frpid=0
else:
	frpid=int(frpid)
print("frpc workid is[%d]" % frpid)
if frpid > 10 :
	print("frpc is running...")
else:
	print("frpc begin starting...")
	print(os.popen("sh {}/stop.sh".format(frpDir)).read())
	print(os.popen("sh {}/stop.sh".format(frpDir)).read())
	print(os.popen("su - {} -c {}/start.sh".format(user,frpDir)).read())
	sendHook("frpc stoped to restart.")
print("3>> end check frpc...")

# parkos service check
print("4>> begin check parkos...")
parkid = os.popen("ps -ef | grep java | grep parkos | grep -v check |  grep -v grep | awk 'NR==1{print $2}'").read()
if parkid=='':
	parkid=0
else:
	parkid=int(parkid)
print("parkos workid is[%d]" % parkid)
if parkid > 10:
	print("parkos is running...")
else:
	print("parkos begin starting...")
	print(os.popen("sh {}/stop.sh".format(parkDir)).read())
	print(os.popen("sh {}/stop.sh".format(parkDir)).read())
	print(os.popen("su - {} -c {}/start.sh".format(user,parkDir)).read())
	sendHook("parkos stoped to restart.")
print("4>> end check parkos...")

# rtsp service check
print("5>> begin check rtsp...")
rtsp1 = os.popen("ps -ef | grep go | grep stream.go | grep -v check |  grep -v grep | awk 'NR==1{print $2}'").read()
rtsp2 = os.popen("ps -ef | grep go | grep go-build | grep -v check |  grep -v grep | awk 'NR==1{print $2}'").read()
if rtsp1=='':
	rtsp1=0
else:
	rtsp1=int(rtsp1)
if rtsp2=='':
	rtsp2=0
else:
	rtsp2=int(rtsp2)
print("rtsp workid is[{}][{}]".format(rtsp1,rtsp2))
if rtsp1 > 10 and rtsp2 > 10:
	print("rtsp is running...")
else:
	print("rtsp begin starting..."+rtspDir)
	print(os.popen("bash {}/stop.sh".format(rtspDir)).read())
	print(os.popen("bash {}/stop.sh".format(rtspDir)).read())
	print(os.popen("su - {} -c {}/start.sh".format(user, rtspDir)).read())
print("5>> end check rtsp...")

# sunlogin service check
print("6>> begin check sunlogin...")
#systemctl start runsunloginclient.service
#systemctl stop runsunloginclient.service
sunid = os.popen("ps -ef | grep sunloginclient | grep -v check |  grep -v grep | awk 'NR==1{print $2}'").read()
if sunid=='':
	sunid=0
else:
	sunid=int(sunid)
print("sunloginclient workid is[%d]" % sunid)
if sunid > 10:
	print("sunloginclient is running...")
else:
	print("sunloginclient begin starting...")
	print(os.system("systemctl stop runsunloginclient.service"))
	print(os.system("systemctl start runsunloginclient.service"))
	#sendHook("sunlogin stoped to restart.")
print("6>> end check sunlogin...")

# easydarwin service check
print("5-1>> begin check easydarwin...")
if os.path.exists(darwinDir) and os.path.isdir(darwinDir):
	rtsp1 = os.popen("ps -ef | grep easydarwin | grep -v check |  grep -v grep | awk 'NR==1{print $2}'").read()
	rtsp2 = os.popen("ps -ef | grep easydarwin.com | grep -v check |  grep -v grep | awk 'NR==1{print $2}'").read()
	if rtsp1=='':
		rtsp1=0
	else:
		rtsp1=int(rtsp1)
	if rtsp2=='':
		rtsp2=0
	else:
		rtsp2=int(rtsp2)
	print("easydarwin workid is[{}][{}]".format(rtsp1,rtsp2))
	if rtsp1 > 10 and rtsp2 > 10 and rtsp1 != rtsp2:
		print("easydarwin is running...")
	else:
		print("easydarwin begin starting..."+darwinDir)
		print(os.popen("cd {} && bash stop.sh".format(darwinDir)).read())
		print(os.popen("cd {} && bash stop.sh".format(darwinDir)).read())
		print(os.popen("cd {} && bash start.sh".format(darwinDir)).read())
else:
	print("easydarwin dir not exist")
print("5-1>> end check easydarwin...")

# easynvr service check
print("5-2>> begin check easynvr...")
if os.path.exists(nvrDir) and os.path.isdir(nvrDir):
	rtsp1 = os.popen("ps -ef | grep easynvr | grep -v check |  grep -v grep | awk 'NR==1{print $2}'").read()
	rtsp2 = os.popen("ps -ef | grep easynvr.com | grep -v check |  grep -v grep | awk 'NR==1{print $2}'").read()
	if rtsp1=='':
		rtsp1=0
	else:
		rtsp1=int(rtsp1)
	if rtsp2=='':
		rtsp2=0
	else:
		rtsp2=int(rtsp2)
	print("easynvr workid is[{}][{}]".format(rtsp1,rtsp2))
	if rtsp1 > 10 and rtsp2 > 10 and rtsp1 != rtsp2:
		print("easynvr is running...")
	else:
		print("easynvr begin starting..."+nvrDir)
		print(os.popen("cd {} && bash stop.sh".format(nvrDir)).read())
		print(os.popen("cd {} && bash stop.sh".format(nvrDir)).read())
		print(os.popen("cd {} && bash start.sh".format(nvrDir)).read())
else:
	print("easynvr dir not exist")
print("5-2>> end check easynvr...")

# easyntd service check
print("5-3>> begin check easyntd...")
if os.path.exists(ntdDir) and os.path.isdir(ntdDir):
	rtsp1 = os.popen("ps -ef | grep easyntd | grep -v check |  grep -v grep | awk 'NR==1{print $2}'").read()
	if rtsp1=='':
		rtsp1=0
	else:
		rtsp1=int(rtsp1)
	print("easyntd workid is[{}]".format(rtsp1))
	if rtsp1 > 10:
		print("easyntd is running...")
	else:
		print("easyntd begin starting..."+ntdDir)
		print(os.popen("cd {} && bash stop.sh".format(ntdDir)).read())
		print(os.popen("cd {} && bash stop.sh".format(ntdDir)).read())
		print(os.popen("cd {} && bash start.sh".format(ntdDir)).read())
else:
	print("easyntd dir not exist")
print("5-3>> end check easyntd...")

#system check
print("7>> begin check system...")
systemCheck()
print("7>> end check system...")

print("end timer service check by %s" % time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(time.time())))
